require 'sms_api/version'
require 'httparty'

##
# TODO
module SmsApi
  include HTTParty
  base_uri 'https://api.smsapi.pl'
  default_params username: ENV['SMSAPI_USERNAME'],
                 password: ENV['SMSAPI_MD5'],
                 format: 'json'
  format :json

  ##
  # Method to send SMS
  # For 'Eco' messages you should pass only msisdn and message
  # For Pro message you should set third argument 'from'
  # usage: SmsApi.sms('MSISDN','message', 'from')
  # Some details about response
  # In response you will recive ['count'] of sended messages,
  # "list" of messages, on list you have some extra data:
  # "id" - message id, You can use it to grab message status,
  # "points" - cost of operation, "error" - error code if will ocure
  def self.sms(to, text, from = 'Eco')
    test = ENV['SMSAPI_TEST'] || 0
    get('/sms.do', query: { to: to, test: test, message: text, from: from })
  end

  ##
  # Method will give count avaliable count/messages on account
  # In case you need specified value you can use as follows:
  # SmsApi.status['points'] - for points count
  # SmsApi.status['proCount'] - for pro messages count
  # SmsApi.status['ecoCount'] - for default messages count
  # SmsApi.status['mmsCount'] - for MMS count
  def self.status
    get('/user.do', query: { credits: 1, details: 1 })
  end
end
